# List templates

`GET /apis/cra.diagrid.io/v1beta1/projects/{ProjectId}/appids/{ProjectSubresourceId}/templates`

List the request templates available for an app ID.

## Request

### Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `ProjectId` | string | Yes | Unique identifier of the project. |
| `ProjectSubresourceId` | string | Yes | Unique identifier of the project subresource. |

### Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `api` | string | No | Filter templates by API type. |
| `op` | string | No | Filter templates by operation type. |

## Responses

### 200 — The list of templates.

`application/json`

- `id` (string)
- `apiType` (string)
- `operationType` (string)
- `scheme` (string)
- `host` (string)
- `port` (string)
- `endpoint` (string)
- `params` (object)
  - `pubsubName` (string[])
  - `stateName` (string[])
  - `appId` (string[])
- `headers` (object[])
  - `key` (string)
  - `value` (string)
- `exampleBody` (string)

`application/vnd.api+json`

JSONAPI.org specification template list response wrapper for UI.

- `data` (object[]) — Required.
  - `data` (object) — Required.
    - `type` (string) — Type of the resource object.
    - `id` (string) — Unique identifier of the resource object.
    - `attributes` (object)
      - `id` (string)
      - `apiType` (string)
      - `operationType` (string)
      - `scheme` (string)
      - `host` (string)
      - `port` (string)
      - `endpoint` (string)
      - `params` (object)
        - `pubsubName` (string[])
        - `stateName` (string[])
        - `appId` (string[])
      - `headers` (object[])
        - `key` (string)
        - `value` (string)
      - `exampleBody` (string)
    - `relationships` (object<string, object>) — Members of the relationships object represent references from the resource object in which it's defined to other resource objects.
      - Any of:
        - **option 1**
        - **option 2**
        - **option 3**
    - `links` (object<string, object>) — Link members related to the primary data.
      - One of:
        - **string (uri-reference)** — A string containing the link's URL.
        - **object**
          - `href` (string (uri-reference)) — Required. A string containing the link's URL.
          - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
    - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
  - `links` (object<string, object>) — Link members related to the primary data.
    - One of:
      - **string (uri-reference)** — A string containing the link's URL.
      - **object**
        - `href` (string (uri-reference)) — Required. A string containing the link's URL.
        - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `included` (object[])
- `links` (object) — Link members related to the primary data.
  - `first` — The first page of data.
    - One of:
      - **string (uri-reference)**
      - **NullType** — Represents a null value.
  - `last` — The last page of data.
    - One of:
      - **string (uri-reference)**
      - **NullType** — Represents a null value.
  - `prev` — The previous page of data.
    - One of:
      - **string (uri-reference)**
      - **NullType** — Represents a null value.
  - `next` — The next page of data.
    - One of:
      - **string (uri-reference)**
      - **NullType** — Represents a null value.
- `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.

### default — Unexpected error.

`application/json`

In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.

- `code` (string) — Required. This is the same as the HTTP status of the response.
- `message` (string) — Required. A short description of the error.
- `status` (object) — Required. A status code that indicates the error type.
- `details` (object) — Additional details about the errors.
  - `@type` (string) — The type of error.
  - `reason` (string) — A reason for the error.
  - `domain` (string) — The domain in which the error occurred.
  - `metadata` (object) — Additional metadata about the error.

`application/vnd.api+json`

JSONAPI.org specification error response wrapper for UI.

- `error` (object) — In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.
  - `code` (string) — Required. This is the same as the HTTP status of the response.
  - `message` (string) — Required. A short description of the error.
  - `status` (object) — Required. A status code that indicates the error type.
  - `details` (object) — Additional details about the errors.
    - `@type` (string) — The type of error.
    - `reason` (string) — A reason for the error.
    - `domain` (string) — The domain in which the error occurred.
    - `metadata` (object) — Additional metadata about the error.
- `meta` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
